import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.sql.Blob;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import oracle.sql.BLOB;

public class SQL {
	private Connection conexao;
	private Statement stm;

	public SQL() {
		this.conexao = null;
		this.stm = null;
	}

	public void conectar() throws ClassNotFoundException, ConexaoSQLException {

		try {
			Class.forName("oracle.jdbc.driver.OracleDriver");
			this.conexao = DriverManager.getConnection(
					"jdbc:oracle:thin:@itapissuma.cin.ufpe.br:1521:dbdisc",
					"g091if685cc_eq06", "oficina123456");
			this.stm = (Statement) this.conexao.createStatement(); // Usamos
			// esse
			// statement
			// para
			// fazer os
			// comandos
			// mysql
		} catch (SQLException e) {
			throw new ConexaoSQLException();
		}
	}

	public void desconectar() throws SQLException {
		if (stm != null) {
			stm.close();
		}
		if (conexao != null && !conexao.isClosed())
			conexao.close();
	}

	public Cliente consultaCliente(String codigo)
			throws ClassNotFoundException, ConexaoSQLException, SQLException {
		this.conectar();
		ResultSet rs = this.stm
				.executeQuery("SELECT * FROM tb_cliente WHERE CPF = " + codigo);
		rs.next();
		System.out.println("consultou");
		Cliente cliente = new Cliente(rs.getString("Nome"), rs.getString("CPF"));
		rs.close();
		this.desconectar();
		return cliente;
	}

	public void inserirFotoNoCliente(String codigoCliente, String caminhoDaFoto)
			throws ClassNotFoundException, ConexaoSQLException, SQLException,
			IOException {
		this.conectar();

		ResultSet rs = stm.executeQuery("SELECT nome, cpf, foto FROM tb_cliente WHERE cpf = "
				+ codigoCliente + " for update");
		rs.next();

		// copia arquivo para campo blob
		Blob blob = rs.getBlob("foto");
		byte[] bbuf = new byte[1024];
		InputStream bin = new FileInputStream(new File(caminhoDaFoto));
		OutputStream bout = ((BLOB) blob).getBinaryOutputStream(); // especfico
		// driver
		// oracle
		// cout = clob.setCharacterStream(0);
		int bytesRead = 0;
		while ((bytesRead = bin.read(bbuf)) != -1) {
			bout.write(bbuf, 0, bytesRead);
		}
		bin.close();
		bout.close();

		conexao.commit();
		this.desconectar();
		System.out.println("inseriu");
	}

	// ve o lance das variaveis de cliente.
	public Cliente getClienteComFoto(String codigoCliente)
			throws ClassNotFoundException, ConexaoSQLException, SQLException,
			IOException {
		this.conectar();
		ResultSet rs = this.stm
				.executeQuery("SELECT nome,cpf, foto FROM tb_cliente WHERE CPF = "
						+ codigoCliente);
		rs.next();
		System.out.println("consultou");
		Cliente retorno = new Cliente(rs.getString("Nome"), rs.getString("CPF"));

		Blob blob = rs.getBlob("foto");
		InputStream bin = blob.getBinaryStream();
		OutputStream bout = new FileOutputStream(retorno.foto);
		int bytesRead = 0;
		byte[] bbuf = new byte[1024];
		while ((bytesRead = bin.read(bbuf)) != -1) {
			bout.write(bbuf, 0, bytesRead);
		}
		bin.close();
		bout.close();

		// fecha cursor
		rs.close();
		
		this.desconectar();
		return retorno;
	}

}
